Index: /palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- /palm/trunk/SOURCE/flow_statistics.f90	(revision 2231)
+++ /palm/trunk/SOURCE/flow_statistics.f90	(revision 2232)
@@ -1042,66 +1251,132 @@
                                              ( ust**2 + vst**2 + w(k,j,i)**2 ) &
                                            * momentumflux_output_conversion(k) &
-                                             * rmask(j,i,sr)
+                                           * rmask(j,i,sr) * flag
              ENDDO
           ENDDO
        ENDDO
+       !$OMP END PARALLEL
+!
+!--    Treat land-surface quantities according to new wall model structure. 
+       IF ( land_surface )  THEN
+          tn = 0
+          !$OMP PARALLEL PRIVATE( i, j, m, tn )
+          !$ tn = omp_get_thread_num()
+          !$OMP DO
+          DO  m = 1, surf_lsm_h%ns
+             i = surf_lsm_h%i(m)
+             j = surf_lsm_h%j(m)
+        
+             IF ( i >= nxl  .AND.  i <= nxr  .AND.                             &
+                  j >= nys  .AND.  j <= nyn )  THEN 
+                sums_l(nzb,93,tn)  = sums_l(nzb,93,tn) + surf_lsm_h%ghf_eb(m)
+                sums_l(nzb,94,tn)  = sums_l(nzb,94,tn) + surf_lsm_h%shf_eb(m)
+                sums_l(nzb,95,tn)  = sums_l(nzb,95,tn) + surf_lsm_h%qsws_eb(m)
+                sums_l(nzb,96,tn)  = sums_l(nzb,96,tn) + surf_lsm_h%qsws_liq_eb(m)
+                sums_l(nzb,97,tn)  = sums_l(nzb,97,tn) + surf_lsm_h%qsws_soil_eb(m)
+                sums_l(nzb,98,tn)  = sums_l(nzb,98,tn) + surf_lsm_h%qsws_veg_eb(m)
+                sums_l(nzb,99,tn)  = sums_l(nzb,99,tn) + surf_lsm_h%r_a(m)
+                sums_l(nzb,100,tn) = sums_l(nzb,100,tn)+ surf_lsm_h%r_s(m)
+             ENDIF
+          ENDDO
+          !$OMP END PARALLEL
+
+          tn = 0
+          !$OMP PARALLEL PRIVATE( i, j, k, m, tn )
+          !$ tn = omp_get_thread_num()
+          !$OMP DO
+          DO  m = 1, surf_lsm_h%ns
+
+             i = surf_lsm_h%i(m)            
+             j = surf_lsm_h%j(m)
+
+             IF ( i >= nxl  .AND.  i <= nxr  .AND.                             &
+                  j >= nys  .AND.  j <= nyn )  THEN 
+
+                DO  k = nzb_soil, nzt_soil
+                   sums_l(k,89,tn)  = sums_l(k,89,tn)  + t_soil_h%var_2d(k,m)  &
+                                      * rmask(j,i,sr)
+                   sums_l(k,91,tn)  = sums_l(k,91,tn)  + m_soil_h%var_2d(k,m)  &
+                                      * rmask(j,i,sr)
+                ENDDO
+             ENDIF
+          ENDDO
+          !$OMP END PARALLEL
+       ENDIF
 !
 !--    For speed optimization fluxes which have been computed in part directly
 !--    inside the WS advection routines are treated seperatly
 !--    Momentum fluxes first:
+
+       tn = 0
+       !$OMP PARALLEL PRIVATE( i, j, k, tn, flag )
+       !$ tn = omp_get_thread_num()
        IF ( .NOT. ws_scheme_mom .OR. sr /= 0  )  THEN
-         !$OMP DO
-         DO  i = nxl, nxr
-            DO  j = nys, nyn
-               DO  k = nzb_diff_s_inner(j,i)-1, nzt_diff
-                  ust = 0.5_wp * ( u(k,j,i)   - hom(k,1,1,sr) +                &
-                                   u(k+1,j,i) - hom(k+1,1,1,sr) )
-                  vst = 0.5_wp * ( v(k,j,i)   - hom(k,1,2,sr) +                &
-                                   v(k+1,j,i) - hom(k+1,1,2,sr) )
-!
-!--               Momentum flux w*u*
-                  sums_l(k,13,tn) = sums_l(k,13,tn) + 0.5_wp *                 &
-                                                    ( w(k,j,i-1) + w(k,j,i) )  &
-                                          * momentumflux_output_conversion(k)  &
-                                                    * ust * rmask(j,i,sr)
-!
-!--               Momentum flux w*v*
-                  sums_l(k,15,tn) = sums_l(k,15,tn) + 0.5_wp *                 &
-                                                    ( w(k,j-1,i) + w(k,j,i) )  &
-                                          * momentumflux_output_conversion(k)  &
-                                                    * vst * rmask(j,i,sr)
-               ENDDO
-            ENDDO
-         ENDDO
+          !$OMP DO
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                DO  k = nzb, nzt
+!
+!--                Flag 23 is used to mask surface fluxes as well as model-top 
+!--                fluxes, which are added further below. 
+                   flag = MERGE( 1.0_wp, 0.0_wp,                               &
+                                 BTEST( wall_flags_0(k,j,i), 23 ) ) *          &
+                          MERGE( 1.0_wp, 0.0_wp,                               &
+                                 BTEST( wall_flags_0(k,j,i), 9  ) )
+
+                   ust = 0.5_wp * ( u(k,j,i)   - hom(k,1,1,sr) +               &
+                                    u(k+1,j,i) - hom(k+1,1,1,sr) )
+                   vst = 0.5_wp * ( v(k,j,i)   - hom(k,1,2,sr) +               &
+                                    v(k+1,j,i) - hom(k+1,1,2,sr) )
+!
+!--                Momentum flux w*u*
+                   sums_l(k,13,tn) = sums_l(k,13,tn) + 0.5_wp *                &
+                                                     ( w(k,j,i-1) + w(k,j,i) ) &
+                                           * momentumflux_output_conversion(k) &
+                                                     * ust * rmask(j,i,sr)     &
+                                                           * flag
+!
+!--                Momentum flux w*v*
+                   sums_l(k,15,tn) = sums_l(k,15,tn) + 0.5_wp *                &
+                                                     ( w(k,j-1,i) + w(k,j,i) ) &
+                                           * momentumflux_output_conversion(k) &
+                                                     * vst * rmask(j,i,sr)     &
+                                                           * flag
+                ENDDO
+             ENDDO
+          ENDDO
 
        ENDIF
        IF ( .NOT. ws_scheme_sca .OR. sr /= 0 )  THEN
-         !$OMP DO
-         DO  i = nxl, nxr
-            DO  j = nys, nyn
-               DO  k = nzb_diff_s_inner(j,i)-1, nzt_diff
-!
-!--               Vertical heat flux
-                  sums_l(k,17,tn) = sums_l(k,17,tn) + 0.5_wp *                 &
+          !$OMP DO
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                DO  k = nzb, nzt
+                   flag = MERGE( 1.0_wp, 0.0_wp,                               &
+                                 BTEST( wall_flags_0(k,j,i), 23 ) ) *          &
+                          MERGE( 1.0_wp, 0.0_wp,                               &
+                                 BTEST( wall_flags_0(k,j,i), 9  ) )
+!
+!--                Vertical heat flux
+                   sums_l(k,17,tn) = sums_l(k,17,tn) + 0.5_wp *                &
                            ( pt(k,j,i)   - hom(k,1,4,sr) +                     &
                              pt(k+1,j,i) - hom(k+1,1,4,sr) )                   &
                            * heatflux_output_conversion(k)                     &
-                           * w(k,j,i) * rmask(j,i,sr)
-                  IF ( humidity )  THEN
-                     pts = 0.5_wp * ( q(k,j,i)   - hom(k,1,41,sr) +            &
+                           * w(k,j,i) * rmask(j,i,sr) * flag
+                   IF ( humidity )  THEN
+                      pts = 0.5_wp * ( q(k,j,i)   - hom(k,1,41,sr) +           &
                                       q(k+1,j,i) - hom(k+1,1,41,sr) )
-                     sums_l(k,49,tn) = sums_l(k,49,tn) + pts * w(k,j,i) *      &
+                      sums_l(k,49,tn) = sums_l(k,49,tn) + pts * w(k,j,i) *     &
                                        waterflux_output_conversion(k) *        &
-                                       rmask(j,i,sr)
-                  ENDIF
-                  IF ( passive_scalar )  THEN
-                     pts = 0.5_wp * ( s(k,j,i)   - hom(k,1,117,sr) +            &
+                                       rmask(j,i,sr) * flag
+                   ENDIF
+                   IF ( passive_scalar )  THEN
+                      pts = 0.5_wp * ( s(k,j,i)   - hom(k,1,117,sr) +           &
                                       s(k+1,j,i) - hom(k+1,1,117,sr) )
-                     sums_l(k,116,tn) = sums_l(k,116,tn) + pts * w(k,j,i) *     &
-                                        rmask(j,i,sr)
-                  ENDIF
-               ENDDO
-            ENDDO
-         ENDDO
+                      sums_l(k,116,tn) = sums_l(k,116,tn) + pts * w(k,j,i) *    &
+                                        rmask(j,i,sr) * flag
+                   ENDIF
+                ENDDO
+             ENDDO
+          ENDDO
 
        ENDIF
@@ -1126,5 +1401,6 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb_s_inner(j,i)+1, nzt
+                DO  k = nzb+1, nzt
+                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
 
                    sums_ll(k,1) = sums_ll(k,1) + 0.5_wp * w(k,j,i) * (         &
@@ -1133,8 +1409,8 @@
                 + ( 0.25_wp * ( v(k,j,i)+v(k+1,j,i)+v(k,j+1,i)+v(k+1,j+1,i) )  &
                             - 0.5_wp * ( hom(k,1,2,sr) + hom(k+1,1,2,sr) ) )**2&
-                + w(k,j,i)**2                                        )
+                + w(k,j,i)**2                                        ) * flag
 
                    sums_ll(k,2) = sums_ll(k,2) + 0.5_wp * w(k,j,i)             &
-                                               * ( p(k,j,i) + p(k+1,j,i) )
+                                               * ( p(k,j,i) + p(k+1,j,i) ) * flag
 
                 ENDDO
@@ -1164,14 +1440,17 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb_s_inner(j,i)+1, nzt
+                DO  k = nzb+1, nzt
+
+                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
 
                    sums_l(k,57,tn) = sums_l(k,57,tn) - 0.5_wp * (              &
                    (km(k,j,i)+km(k+1,j,i)) * (e(k+1,j,i)-e(k,j,i)) * ddzu(k+1) &
                  - (km(k-1,j,i)+km(k,j,i)) * (e(k,j,i)-e(k-1,j,i)) * ddzu(k)   &
-                                                                ) * ddzw(k)
+                                                                ) * ddzw(k)    &
+                                                                  * flag
 
                    sums_l(k,69,tn) = sums_l(k,69,tn) - 0.5_wp * (              &
                    (km(k,j,i)+km(k+1,j,i)) * (e(k+1,j,i)-e(k,j,i)) * ddzu(k+1) &
-                                                                )
+                                                                )  * flag
 
                 ENDDO
@@ -1191,5 +1470,6 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb_s_inner(j,i)+1, nzt
+                DO  k = nzb+1, nzt
+                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
 !
 !--                Subgrid horizontal heat fluxes u"pt", v"pt"
@@ -1199,5 +1479,5 @@
                                                * rho_air_zw(k)                 &
                                                * heatflux_output_conversion(k) &
-                                                 * ddx * rmask(j,i,sr)
+                                                 * ddx * rmask(j,i,sr) * flag
                    sums_l(k,61,tn) = sums_l(k,61,tn) - 0.5_wp *                &
                                                    ( kh(k,j,i) + kh(k,j-1,i) ) &
@@ -1205,5 +1485,5 @@
                                                * rho_air_zw(k)                 &
                                                * heatflux_output_conversion(k) &
-                                                 * ddy * rmask(j,i,sr)
+                                                 * ddy * rmask(j,i,sr) * flag
 !
 !--                Resolved horizontal heat fluxes u*pt*, v*pt*
@@ -1212,5 +1492,6 @@
                                     * 0.5_wp * ( pt(k,j,i-1) - hom(k,1,4,sr) + &
                                                  pt(k,j,i)   - hom(k,1,4,sr) ) &
-                                               * heatflux_output_conversion(k)
+                                               * heatflux_output_conversion(k) &
+                                               * flag
                    pts = 0.5_wp * ( pt(k,j-1,i) - hom(k,1,4,sr) +              &
                                     pt(k,j,i)   - hom(k,1,4,sr) )
@@ -1219,5 +1500,6 @@
                                     * 0.5_wp * ( pt(k,j-1,i) - hom(k,1,4,sr) + &
                                                  pt(k,j,i)   - hom(k,1,4,sr) ) &
-                                               * heatflux_output_conversion(k)
+                                               * heatflux_output_conversion(k) &
+                                               * flag
                 ENDDO
              ENDDO
@@ -1279,41 +1561,30 @@
        ENDIF
 
+       tn = 0
        !$OMP PARALLEL PRIVATE( i, j, k, tn )
-!$     tn = omp_get_thread_num()
-       IF ( land_surface )  THEN
-          !$OMP DO
-          DO  i = nxl, nxr
-             DO  j =  nys, nyn
-                DO  k = nzb_soil, nzt_soil
-                   sums_l(k,89,tn)  = sums_l(k,89,tn)  + t_soil(k,j,i)         &
-                                      * rmask(j,i,sr)
-                   sums_l(k,91,tn)  = sums_l(k,91,tn)  + m_soil(k,j,i)         &
-                                      * rmask(j,i,sr)
-                ENDDO
-             ENDDO
-          ENDDO
-       ENDIF
-       
+       !$ tn = omp_get_thread_num()       
        IF ( radiation .AND. radiation_scheme == 'rrtmg' )  THEN
           !$OMP DO
           DO  i = nxl, nxr
              DO  j =  nys, nyn
-                DO  k = nzb_s_inner(j,i)+1, nzt+1
+                DO  k = nzb+1, nzt+1
+                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
+
                    sums_l(k,102,tn)  = sums_l(k,102,tn)  + rad_lw_in(k,j,i)    &
-                                       * rmask(j,i,sr)
+                                       * rmask(j,i,sr) * flag
                    sums_l(k,103,tn)  = sums_l(k,103,tn)  + rad_lw_out(k,j,i)   &
-                                       * rmask(j,i,sr)
+                                       * rmask(j,i,sr) * flag
                    sums_l(k,104,tn)  = sums_l(k,104,tn)  + rad_sw_in(k,j,i)    &
-                                       * rmask(j,i,sr)
+                                       * rmask(j,i,sr) * flag
                    sums_l(k,105,tn)  = sums_l(k,105,tn)  + rad_sw_out(k,j,i)   &
-                                       * rmask(j,i,sr)
+                                       * rmask(j,i,sr) * flag
                    sums_l(k,106,tn)  = sums_l(k,106,tn)  + rad_lw_cs_hr(k,j,i) &
-                                       * rmask(j,i,sr)
+                                       * rmask(j,i,sr) * flag
                    sums_l(k,107,tn)  = sums_l(k,107,tn)  + rad_lw_hr(k,j,i)    &
-                                       * rmask(j,i,sr)
+                                       * rmask(j,i,sr) * flag
                    sums_l(k,108,tn)  = sums_l(k,108,tn)  + rad_sw_cs_hr(k,j,i) &
-                                       * rmask(j,i,sr)
+                                       * rmask(j,i,sr) * flag
                    sums_l(k,109,tn)  = sums_l(k,109,tn)  + rad_sw_hr(k,j,i)    &
-                                       * rmask(j,i,sr)
+                                       * rmask(j,i,sr) * flag
                 ENDDO
              ENDDO
Index: /palm/trunk/SOURCE/header.f90
===================================================================
--- /palm/trunk/SOURCE/header.f90	(revision 2231)
+++ /palm/trunk/SOURCE/header.f90	(revision 2232)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adjustments to new topography and surface concept
+! Generic tunnel setup added
 ! 
 ! Former revisions:
@@ -293,6 +294,5 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  pt_init, qsws, q_init, s_init, sa_init, shf, ug, vg, w_subs, zu,&
-               zw
+        ONLY:  pt_init, q_init, s_init, sa_init, ug, vg, w_subs, zu, zw
         
     USE control_parameters
@@ -320,5 +320,5 @@
  
     USE land_surface_model_mod,                                                &
-        ONLY: land_surface, lsm_header
+        ONLY: lsm_header
 
     USE microphysics_mod,                                                      &
@@ -362,4 +362,7 @@
     USE spectra_mod,                                                           &
         ONLY:  calculate_spectra, spectra_header
+
+    USE surface_mod,                                                           &
+        ONLY:  surf_def_h
 
     IMPLICIT NONE
@@ -933,4 +936,30 @@
           ENDIF
 
+       CASE ( 'tunnel' )
+          IF ( tunnel_width_x /= 9999999.9_wp )  THEN
+!
+!--          Tunnel axis in y direction
+             IF ( tunnel_length == 9999999.9_wp  .OR.                          &
+                  tunnel_length >= ( nx + 1 ) * dx )  THEN
+                WRITE ( io, 273 )  'y', tunnel_height, tunnel_wall_depth,      &
+                                        tunnel_width_x
+             ELSE
+                WRITE ( io, 274 )  'y', tunnel_height, tunnel_wall_depth,      &
+                                        tunnel_width_x, tunnel_length
+             ENDIF
+
+          ELSEIF ( tunnel_width_y /= 9999999.9_wp )  THEN
+!
+!--          Tunnel axis in x direction
+             IF ( tunnel_length == 9999999.9_wp  .OR.                          &
+                  tunnel_length >= ( ny + 1 ) * dy )  THEN
+                WRITE ( io, 273 )  'x', tunnel_height, tunnel_wall_depth,      &
+                                        tunnel_width_y
+             ELSE
+                WRITE ( io, 274 )  'x', tunnel_height, tunnel_wall_depth,      &
+                                        tunnel_width_y, tunnel_length
+             ENDIF
+          ENDIF
+
     END SELECT
 
@@ -1065,5 +1094,5 @@
        IF ( constant_heatflux )  THEN
           IF ( large_scale_forcing .AND. lsf_surf )  THEN
-             WRITE ( io, 306 )  shf(0,0)
+             IF ( surf_def_h(0)%ns >= 1 )  WRITE ( io, 306 )  surf_def_h(0)%shf(1)
           ELSE
              WRITE ( io, 306 )  surface_heatflux
@@ -1073,5 +1102,5 @@
        IF ( humidity  .AND.  constant_waterflux )  THEN
           IF ( large_scale_forcing .AND. lsf_surf )  THEN
-             WRITE ( io, 311 ) qsws(0,0)
+             WRITE ( io, 311 ) surf_def_h(0)%qsws(1)
           ELSE
              WRITE ( io, 311 ) surface_waterflux
@@ -2024,4 +2053,14 @@
               ' Canyon height: ', F6.2, 'm, ch = ', I4, '.'      / &
               ' Canyon position (',A,'-walls): cxl = ', I4,', cxr = ', I4, '.')
+273 FORMAT (  ' Tunnel of infinite length in ',A, &
+              ' direction' / &
+              ' Tunnel height: ', F6.2, / &
+              ' Tunnel-wall depth: ', F6.2      / &
+              ' Tunnel width: ', F6.2 )
+274 FORMAT (  ' Tunnel in ', A, ' direction.' / &
+              ' Tunnel height: ', F6.2, / &    
+              ' Tunnel-wall depth: ', F6.2      / &
+              ' Tunnel width: ', F6.2, / &
+              ' Tunnel length: ', F6.2 )
 278 FORMAT (' Topography grid definition convention:'/ &
             ' cell edge (staggered grid points'/  &
